package cs4621.lecture02;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.media.opengl.awt.GLCanvas;
import javax.media.opengl.GL2;
import javax.media.opengl.GLAutoDrawable;
import javax.media.opengl.GLCapabilities;
import javax.media.opengl.GLEventListener;
import javax.media.opengl.GLProfile;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.Timer;

import com.jogamp.opengl.util.FPSAnimator;


public class Demo13 extends JFrame implements GLEventListener, ActionListener
{		
	private GLCanvas canvas;
	private JButton toggleDepthTestButton;
	private boolean useDepthTest;
	
	public Demo13() {		
		super("CS 4621 Demo 13: Effect of Depth Test.");		
		
		GLProfile profile = GLProfile.getDefault();
		GLCapabilities capabilities = new GLCapabilities(profile);
		canvas = new GLCanvas(capabilities);
		canvas.addGLEventListener(this);
						
		getContentPane().add(canvas, BorderLayout.CENTER);
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);		
		
		toggleDepthTestButton = new JButton("Toggle Depth Test: OFF");
		toggleDepthTestButton.addActionListener(this);
		getContentPane().add(toggleDepthTestButton, BorderLayout.SOUTH);
		useDepthTest = false;
	}
	
	public void run()
	{
		setSize(512, 512);
		setLocationRelativeTo(null);		
		setVisible(true);
	}
	
	public static void main(String[] args) {		
		new Demo13().run();		
	}

	@Override
	public void init(GLAutoDrawable drawable) {		
		// NOP
	}	

	@Override
	public void display(GLAutoDrawable drawable) {
		final GL2 gl = drawable.getGL().getGL2();
		
		gl.glClearColor(0, 0, 0, 0);
		if (useDepthTest)
		{
			gl.glEnable(GL2.GL_DEPTH_TEST);
			gl.glClearDepth(1.0);
			gl.glClear(GL2.GL_COLOR_BUFFER_BIT | GL2.GL_DEPTH_BUFFER_BIT);
		}
		else
		{
			gl.glDisable(GL2.GL_DEPTH_TEST);
			gl.glClear(GL2.GL_COLOR_BUFFER_BIT);
		}
	
		gl.glColor3d(0.5, 1, 0.5);
		gl.glBegin(GL2.GL_TRIANGLES);
		gl.glVertex3d(0, 0.5, 0);
		gl.glVertex3d(-0.5, -0.5, 0);
		gl.glVertex3d(0.5, -0.5, 0);
		gl.glEnd();

		gl.glColor3d(1, 0.5, 0.5);
		gl.glBegin(GL2.GL_TRIANGLES);
		gl.glVertex3d(0, -0.75, 1);
		gl.glVertex3d(0.40, 0, 1);
		gl.glVertex3d(-0.40, 0.30, -1);
		gl.glEnd();

	}

	@Override
	public void reshape(GLAutoDrawable drawble, 
			int x, int y, int width, int height) {
		// NOP
	}

	@Override
	public void dispose(GLAutoDrawable drawable) {
		// NOP		
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == toggleDepthTestButton)
		{
			if (useDepthTest)
			{
				toggleDepthTestButton.setText("Toggle Depth Test: OFF");
				useDepthTest = false;
				canvas.repaint();
			}
			else
			{
				toggleDepthTestButton.setText("Toggle Depth Test: ON");
				useDepthTest = true;
				canvas.repaint();
			}
		}		
	}	
}
